#include <FilterDerivative.h>
#include <FilterOnePole.h>
#include <Filters.h>
#include <FilterTwoPole.h>
#include <FloatDefine.h>
#include <RunningStatistics.h>

int pulseSignal = 0; // the filtered sensor signal
int pulseCount = 0; // keeps track of pulse number in order to calculate heart rate
int heartRate; //heart rate in bpm based on the time it takes for 10 heart beats
float startTime; //time when first heart beat occurs. this resets every 10 heart beats in order to calculate a heart rate
float stopTime; //time when 10th heart beat occurs
boolean pulseHigh = false ; //true when signal goes high, false when signal goes low

void setup() {
  Serial.begin(9600);
  pinMode(8, OUTPUT);
}

void printPulseSignal(float pulseSignal){
  Serial.println(int(pulseSignal));
  
  if (pulseSignal>0){
    digitalWrite(8,HIGH);
  }
  else{
    digitalWrite(8,LOW);
  }
}


// filter out frequencies below 0.5 Hz.
float highFilterFrequency = 0.5;  

// create a highpass filter that only keeps frequencies above highFilterFrequency
FilterOnePole filterOneHighpass( HIGHPASS, highFilterFrequency );  

// filters out frequenceies greater than 2 Hz.
float lowFilterFrequency = 2;  

// create a lowpass filter that only keeps frequencies below lowFilterFrequency
FilterOnePole filterOneLowpass( LOWPASS, lowFilterFrequency );  


void loop() {
  
  //The next line applies a band pass filter to the signal
  
  filterOneLowpass.input(filterOneHighpass.input(analogRead(A0)));
  
  pulseSignal = 100*filterOneLowpass.output(); //scale the filtered pulse signal (this might be unnecessary)
    
  printPulseSignal(pulseSignal);

}
